/********************************************************************
 * DESCRIPTION : I do not know what these function do exactly.
 *               I just copy it from several source.
 *               I hate hardware programming, 
 *               but I have studied how hardware work for 2 years
 *               to make my own OS. It is so difficult to me. ;-)
 *               The most important thing is I cannot write any
 *               description this file. :-(
 * FILE NAME : InitIRQ.c
 *******************************************************************/
#include <IRQ.h>



/*
 * Initialize PIC(8259)
 * Initialize IRQ handlers to UnidentifiedIRQ function.
 * This function is called by main() function.
 */
void InitIRQ( void )
{
	int	i;

	
	/* initialize hardware interrupt base vector... */
	outb( 0x20, 0x11 );
	outb( 0xa0, 0x11 );
	
	outb( 0x21, IRQ_VECTOR );
	outb( 0xa1, IRQ_VECTOR+8 );
	
	outb( 0x21, 0x04 );
	outb( 0xa1, 0x02 );
	
	outb( 0x21, 0x01 );
	outb( 0xa1, 0x01 );
	
	/* irq 2 ¸¦ Á¦¿ÜÇÑ ¸ðµç irq ¸¦ disable ÇÑ´Ù... */
	outb( 0x21, irqMask0_7 );
	outb( 0xa1, irqMask8_15 );

	
	for( i = 0; i < MAX_IRQ; i++ )
		IRQHandler[i]	= UnidentifiedIRQ;
}

/*
 * enable specified IRQ by store mask bit.
 */
void EnableIRQ( int irq )
{
	irqMask	= irqMask & ~(1<<irq);

	if( irq & 8 )
		outb( 0xa1, irqMask8_15 );
	else
		outb( 0x21, irqMask0_7 );
}

/*
 * disable specified irq by set mask bit
 */
void DisableIRQ( int irq )
{
	irqMask	= irqMask | (1<<irq);

	if( irq & 8 )
		outb( 0xa1, irqMask8_15 );
	else
		outb( 0x21, irqMask0_7 );
}

/*
 * register handler of specified IRQ.
 * store function pointer of handler with IRQHandler array 
 */
void RegisterIRQHandler( int irq, IRQHandler_t handler )
{
	IRQHandler[irq]	= handler;
}

/*
 * unregister handler of specified IRQ
 * store NULL pointer with array
 */
void UnregisterIRQHandler( int irq )
{
	IRQHandler[irq]	= NULL;
}

/*
 * At fist, it send EOI signal to PIC,
 * and set mask of specified irq to disable it
 * At last because CPU enable interrups automatically
 * it enable interrupts with sti() function.
 */
static int DoIRQ( int irq )
{
	/* eoi(end of interrupt) ¸¦ ¹Ù·Î Àü¼ÛÇÑ´Ù...
	 * ÀÎÅÍ·´Æ®¸¦ Ã³¸®ÇÏ´Â µ¿¾ÈÀº irqMask ¸¦ ÅëÇØ ÀÎÅÍ·´Æ®¸¦ Â÷´ÜÇÑ´Ù...
	 */
	if( irq & 8 )
	{
		inb( 0xa1 );
		outb( 0xa1, irqMask8_15 | (1<<irq) );
		outb( 0xa0, 0x60+(irq&7) );
		outb( 0x20, 0x62 );
	}
	else
	{
		inb( 0x21 );
		outb( 0x21, irqMask0_7 | (1<<irq) );
		outb( 0x20, 0x60+irq );
	}

	if( irqMask & (1<<irq) )
		return -1;

	irqMask	|= (1<<irq);

	/* ÀÎÅÍ·´Æ® ¹ß»ý½Ã ÀÚµ¿À¸·Î ÀÎÅÍ·´Æ®°¡ Â÷´ÜµÇ¹Ç·Î ±×°É ÇØÁ¦ÇØÁØ´Ù... */
	sti();

	return 0;
}

/*
 * If the handler of specified irq is endded,
 * it restore masking bit to enable irq.
 */
static void EndIRQ( int irq )
{
	irqMask	&= ~(1<<irq);

	if( irq & 8 )
		outb( 0xa1, irqMask8_15 );
	else
		outb( 0x21, irqMask0_7 );
}

/*
 * When the irq is requested HandleIRQ() starts.
 * It invoke DoIRQ to enable other irqs,
 * run IRQ handler.
 * IF the handler is over, 
 * it enable the irq which are disabled by DoIRQ() at EndIRQ().
 */
void HandleIRQ( int irq )
{
	if( DoIRQ(irq) < 0 )
		return;
		
	IRQHandler[irq]();

	EndIRQ( irq );
}
